<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<title>Bootsrap-Flex</title>

		<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
	</head>

	<body>
		<div class="container-fluid text-center">

			<h1>Bootsrap Flex</h1>
			<p>Used the d-flex class to create a flex container and transform direct children into flex item.</p>

			<!-- align-item-center - class will vertically center all the child elements. It will only work if div or container is flex. (align-items-center/end/start) -->

			<!-- justify-content-center - it will horizontaly center all the cghild elements, it will only accessible if display value is flex. (justify-content-center/end/start) -->

			<!-- d-flex - the flex that will change the elements into block level container and it will make all the elements become flexible that allows them to occupy space enough for the content of an element and at the same time wil have the elemnts appear beside each other. (flex-row or flex-column) -->
			<div style="height:500px" class="bg-dark d-flex flex-column p-3 align-items-center justify-content-center">
				<div class="p-3 bg-success col-2">Flex Item A</div>
				<div class="p-3 bg-warning col-2">Flex Item B</div>
				<div class="p-3 bg-danger col-2">Flex Item C</div>
			</div>

			<h2>Flex row</h2>
				<div class="bg-dark p-3 d-flex flex-row justify-content-center">
					<div class="p-3 bg-success col-2">Flex Item A</div>
					<div class="p-3 bg-warning col-2">Flex Item B</div>
					<div class="p-3 bg-danger col-2">Flex Item C</div>
				</div>

			<h2>Flex Row Reverse</h2>
				<div class="bg-dark p-3 d-flex flex-row-reverse">
					<div class="p-3 bg-success col-2">Flex Item A</div>
					<div class="p-3 bg-warning col-2">Flex Item B</div>
					<div class="p-3 bg-danger col-2">Flex Item C</div>
				</div>

			<h2>Create space between elements</h2>
				<div class="bg-dark p-3 d-md-flex flex-row justify-content-around">
					<div class="p-3 bg-success">Flex Item A</div>
					<div class="p-3 bg-warning">Flex Item B</div>
					<div class="p-3 bg-danger">Flex Item C</div>
				</div>

			<h2>Flex Box with margin</h2>
				<!-- mr-auto - margin right-auto -->
				<div class="bg-dark p-3 d-flex flex-row">
					
					<div class="p-3 bg-success">Flex Item A</div>
					<div class="p-3 bg-warning">Flex Item B</div>
					<div class="p-3 bg-danger ml-auto">Flex Item C</div>
					<div class="p-3 bg-primary">Flex Item D</div>
				</div>

				<h2>nested flex elements</h2>
				<div class="bg-dark p-3 d-flex flex-row">
					<div class="p-3 bg-success mr-auto">Flex Item A</div>

					<div class="d-flex flex justify-content-between w-50">
						<div class="p-3 bg-warning">Flex Item B</div>
						<div class="p-3 bg-danger">Flex Item C</div>
						<div class="p-3 bg-primary">Flex Item D</div>
					</div>
				</div>




		</div>

		<!-- Jvascript of the bootsrap -->
		<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
		<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>

	</body>
</html>